#include <iostream>
#include <vector>
using namespace std;

class Int {
public:
    Int() : n {0}
    {}
    Int(int n) : n {n}
    {}

    Int operator + (const Int& b)
    {
        return Int(n + b.n);
    }

    Int& operator += (const Int& b)
    {
        n += b.n;
        return *this;
    }
    int GetN() const
    {
        return n;
    }
private:
    int n;
};

int main()
{
    Int a {10}, b {20};

    a += b;  // a.operator += (b);
    cout << a.GetN();
}
