// Polimorfism
#include <iostream>
using namespace std;
// Functii virtuale

class Fiinta {
public:
    virtual void SeHraneste() const
    {
        cout << __PRETTY_FUNCTION__ << '\n';
    }
};

class Om : public Fiinta {
public:
    void SeHraneste() const // Overriding
    {
        cout << __PRETTY_FUNCTION__ << '\n';
    }
};

class Animal : public Fiinta {
public:
    void SeHraneste() const
    {
        cout << __PRETTY_FUNCTION__ << '\n';
    }
};

class Caine : public Animal {
public:
    void SeHraneste() const
    {
        cout << __PRETTY_FUNCTION__ << '\n';
    }
};

/* Spunem ca functia SeHraneste() are un comportament polimorfic
    Obiectele care contin functii virtuale se numesc POLIMORFICE

*/

int main()
{
    Fiinta* pf;

    char c;
    cin >> c;
    switch (c)
    {
        case 'f' : pf = new Fiinta();
                   pf->SeHraneste();
                   break;
        case 'o' : pf = new Om();
                   pf->SeHraneste();
                   break;
        case 'a' : pf = new Animal();
                   pf->SeHraneste();
                   break;
        case 'c' : pf = new Caine();
                   pf->SeHraneste();
                   break;
        default: cout << "Nu s-a creat niciun obiect";
    }
}
