#include <iostream>
#include <vector>
using namespace std;

class Int {
public:
    Int() : n {0}
    {}
    Int(int n) : n {n}
    {}

    bool operator < (const Int& b)
    {
        return n < b.n;
    }
    bool operator <= (const Int& b)
    {
        return n <= b.n;
    }
    bool operator > (const Int& b)
    {
        return n > b.n;
    }
    bool operator >= (const Int& b)
    {
        return n >= b.n;
    }
    bool operator != (const Int& b)
    {
        return n != b.n;
    }
    bool operator == (const Int& b)
    {
        return n == b.n;
    }
    int GetN() const
    {
        return n;
    }
private:
    int n;
};

int main()
{
    Int a {10}, b {20};

    if ( a < b) // a.operator < (b)
        cout << "a < b\n";

    if ( a != b) // a.operator < (b)
        cout << "a != b\n";


    if (a.operator <= (b))
        cout << "a <= b";
}
