#include <iostream>
using namespace std;

class Fiinta {
public:
    void SeHraneste() const
    {
        cout << __PRETTY_FUNCTION__ << '\n';
    }
};

class Om : public Fiinta {
public:
    void SeHraneste() const
    {
        cout << __PRETTY_FUNCTION__ << '\n';
    }
};

class Animal : public Fiinta {
public:
    void SeHraneste() const
    {
        cout << __PRETTY_FUNCTION__ << '\n';
    }
};

class Caine : public Animal {
public:
    void SeHraneste() const
    {
        cout << __PRETTY_FUNCTION__ << '\n';
    }
};

/* Legare Statica (Static Binding, Early Binding)
   Legare: Asocierea unui apel de functie cu codul care se va executa
   Daca decizia legare se ia compile-time, atunci se va executa functia
   definita in clasa de baza (Fiinta). Conteaza tipul pointerului, nu tipul obiectului creat dinamic
*/

int main()
{
    Fiinta* pf;

    pf = new Fiinta();
    pf->SeHraneste(); // -> Operator de Acces Indirect la membri clasei
    delete pf;


    pf = new Om();         // Legare statica
    pf->SeHraneste();
    delete pf;

    pf = new Animal();     // Legare statica
    pf->SeHraneste();
    delete pf;

    pf = new Caine();      // Legare statica
    pf->SeHraneste();
    delete pf;
}
